package weaver.interfaces.xmgsecond;

import com.engine.kq.biz.KQLeaveRulesComInfo;
import com.engine.kq.biz.KQUsageHistoryBiz;
import com.engine.kq.entity.KQUsageHistoryEntity;
import com.engine.kq.jucailin.util.KQDateUtil;
import com.weaver.general.TimeUtil;
import weaver.conn.RecordSet;
import weaver.general.Util;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

import java.util.ArrayList;
import java.util.List;

/**
 * @Author liang.cheng
 * @Date 2025/5/15 14:10
 * @Description: 新美光假期额度申请流程
 * @Version 1.0
 */
public class BalanceOfLeaveAction implements Action{


    @Override
    public String execute(RequestInfo requestInfo) {
        String requestid = requestInfo.getRequestid();
        int formid = Math.abs(requestInfo.getRequestManager().getFormid());
        RecordSet rs = new RecordSet();
        String mainTable = String.format("%s%s", "formtable_main_", formid);


        String currentDate = TimeUtil.getCurrentDateString();
        String currentTime = TimeUtil.getOnlyCurrentTimeString();
        java.sql.Timestamp date = KQDateUtil.getUpdateTimeStamp();
//        String creator = requestInfo.getRequestManager().getCurrentOperator().;
        String creator = "1";

        rs.executeQuery("select xm,edssny,qjlx,ewsfed from "+mainTable+" where requestid = ?",requestid);
        rs.next();
        //假期类型的ID
        String leaveRulesId = Util.null2String(rs.getString("qjlx"));
        String searchYear = Util.null2String(rs.getString("edssny"));
        String resourceId = Util.null2String(rs.getString("xm"));
        double extraAmount = Util.getDoubleValue(rs.getString("ewsfed"), 0);
        //获取假期类型的缓存类
        KQLeaveRulesComInfo kqLeaveRulesComInfo = new KQLeaveRulesComInfo();
        //请假最小单位：1-按天请假、2-按半天请假、3-按小时请假、4-按整天请假
        String minimumUnit = kqLeaveRulesComInfo.getMinimumUnit(leaveRulesId);
        String insertOrUpdate = "";
        String oldBaseAmount = "0";
        String oldUsedAmount = "0";
        String oldExtraAmount = "0";
        String oldBaseAmount2 = "0";
        String oldUsedAmount2 = "0";
        String oldExtraAmount2 = "0";

        String newExtraAmount = "0";

        boolean flag = true;
        //在数据库里是否已经存在记录了
        rs.executeQuery("select baseAmount,extraAmount,usedAmount,baseAmount2,extraAmount2,usedAmount2 from kq_BalanceOfLeave where leaveRulesId=? and resourceId=? and belongYear=? order by id", leaveRulesId, resourceId, searchYear);
        if (rs.next()) {

            oldBaseAmount = "" + Util.getDoubleValue(rs.getString("baseAmount"), 0);
            oldExtraAmount = "" + Util.getDoubleValue(rs.getString("extraAmount"), 0);
            oldUsedAmount = "" + Util.getDoubleValue(rs.getString("usedAmount"), 0);

            oldBaseAmount2 = "" + Util.getDoubleValue(rs.getString("baseAmount2"), 0);
            oldExtraAmount2 = "" + Util.getDoubleValue(rs.getString("extraAmount2"), 0);
            oldUsedAmount2 = "" + Util.getDoubleValue(rs.getString("usedAmount2"), 0);

            newExtraAmount = String.valueOf(extraAmount + Util.getDoubleValue(rs.getString("extraAmount"), 0));
            insertOrUpdate = "update";


            String updateSql = "update kq_BalanceOfLeave set baseAmount=?,extraAmount=?,usedAmount=?,baseAmount2=?,extraAmount2=?,usedAmount2=?,update_time=? where leaveRulesId=? and resourceId=? and belongYear=?";
            flag = rs.executeUpdate(updateSql, oldBaseAmount, newExtraAmount, oldUsedAmount, oldBaseAmount2, oldExtraAmount2, oldUsedAmount2,date, leaveRulesId, resourceId, searchYear);

            if (!flag) {
                requestInfo.getRequestManager().setMessagecontent("更新员工假期余额失败");
                return Action.FAILURE_AND_CONTINUE;
            }

        }else {
            newExtraAmount = "" + extraAmount;
            insertOrUpdate = "insert";

            String insertSql = "insert into kq_BalanceOfLeave(baseAmount,extraAmount,usedAmount,baseAmount2,extraAmount2,usedAmount2,leaveRulesId,resourceId,belongYear,create_time,update_time,creator) values(?,?,?,?,?,?,?,?,?,?,?,?)";
            flag = rs.executeUpdate(insertSql, oldBaseAmount, newExtraAmount, oldUsedAmount, oldBaseAmount2, oldExtraAmount2, oldUsedAmount2, leaveRulesId, resourceId, searchYear,date,date,creator);



            if (!flag) {
                requestInfo.getRequestManager().setMessagecontent("新增员工假期余额失败");
                return Action.FAILURE_AND_CONTINUE;
            }
        }

        List<KQUsageHistoryEntity> usageHistoryEntityList = new ArrayList<>();
        KQUsageHistoryEntity usageHistoryEntity = new KQUsageHistoryEntity();
        usageHistoryEntity.setLeaveRulesId(leaveRulesId);
        usageHistoryEntity.setRelatedId(resourceId);
        usageHistoryEntity.setOperator(creator);
        usageHistoryEntity.setOperateDate(currentDate);
        usageHistoryEntity.setOperateTime(currentTime);
        usageHistoryEntity.setOperateType("5");
        usageHistoryEntity.setBelongYear(searchYear);
        usageHistoryEntity.setOldBaseAmount(oldBaseAmount);
        usageHistoryEntity.setNewBaseAmount(oldBaseAmount);
        usageHistoryEntity.setOldExtraAmount(oldExtraAmount);
        usageHistoryEntity.setNewExtraAmount(newExtraAmount);
        usageHistoryEntity.setOldUsedAmount(oldUsedAmount);
        usageHistoryEntity.setNewUsedAmount(oldUsedAmount);
        usageHistoryEntity.setOldBaseAmount2(oldBaseAmount2);
        usageHistoryEntity.setNewBaseAmount2(oldBaseAmount2);
        usageHistoryEntity.setOldExtraAmount2(oldExtraAmount2);
        usageHistoryEntity.setNewExtraAmount2(oldExtraAmount2);
        usageHistoryEntity.setOldUsedAmount2(oldUsedAmount2);
        usageHistoryEntity.setNewUsedAmount2(oldUsedAmount2);
        usageHistoryEntity.setOldMinimumUnit(minimumUnit);
        usageHistoryEntity.setNewMinimumUnit(minimumUnit);
        usageHistoryEntity.setInsertOrUpdate(insertOrUpdate);

        usageHistoryEntityList.add(usageHistoryEntity);


        if (usageHistoryEntityList.size() > 0) {
            KQUsageHistoryBiz usageHistoryBiz = new KQUsageHistoryBiz();
            flag = usageHistoryBiz.save(usageHistoryEntityList);
            if (!flag) {
                requestInfo.getRequestManager().setMessagecontent("员工假期余额变更记录日志失败");
                return Action.FAILURE_AND_CONTINUE;
            }
        }

        return Action.SUCCESS;
    }
}
